# Cancel or end an auction

### Prerequisites

Before getting started, make sure you have the following ready:

1. [Create a Ternoa](/getting-started/wallets/ternoa-wallet.md) account with [Alphanet CAPS](broken://pages/ej9gceaLIhCN2PgUBh42)
2. Install and set up your editor of choice (we will use Visual Studio Code \[VSC] in this tutorial)
3. Install [NodeJS v.14+](https://nodejs.org/en/download/) & NPM
4. [Install & initialize Ternoa-JS](/build-1/javascript/ternoa-js-library-utilities/installation-and-initialization.md)

### Cancel an auction on a marketplace using Ternoa-JS

This function cancels an auctioned NFT from a marketplace on the Ternoa chain. It returns an object promise containing the AuctionCancelledEvent provided by the Ternoa blockchain.

{% hint style="info" %}
Use your own account by updating the `//TernoaTestAccount` with your account seed when retrieving the keyring from the example below. **Replace the NFT\_ID** with the existing one to cancel. Note: **This transaction can only be submitted if the auction has not started yet.**&#x20;
{% endhint %}

```typescript
import {
    cancelAuction,
    initializeApi,
    getKeyringFromSeed,
    WaitUntil,
} from "ternoa-js";

const cancelAuctionNFT = async () => {
    try {
        await initializeApi();
        const keyring = await getKeyringFromSeed("//TernoaTestAccount");
        const NFT_ID = // update with the auctioned nft id you want to cancel.
        const res = await cancelAuction(
            NFT_ID,
            keyring,
            WaitUntil.BlockInclusion
        );
        console.log(`Auction cancelled for NFT id: ${res.nftId}`);
    } catch (e) {
        console.error(e);
    }
};
```

#### The expected params

```markdown
`nftId`: The ID of the auctioned NFT to cancel.
`keyring`: The provided keyring (containing the address) will be used to sign the transaction and pay the execution fee.
`waitUntil`: WaitUntil defines at which point we want to get the results of the transaction execution: BlockInclusion or BlockFinalization.
```

#### Response

The response provided from the blockchain event includes all the information below according to the parameters provided when canceling an auction.

```markdown
`nftId`: NFT id of the canceled auction.
```

### End an auction on a marketplace using Ternoa-JS

This function ends an auctioned NFT from a marketplace on the Ternoa chain. It returns an object promise containing the AuctionCompletedEvent provided by the Ternoa blockchain.

{% hint style="info" %}
Use your own account by updating the `//TernoaTestAccount` with your account seed when retrieving the keyring from the example below. **Replace the NFT\_ID** with the existing one to end. Note: **This transaction can only be submitted if the auction has entered the ending period.**
{% endhint %}

```typescript
import {
    endAuction,
    initializeApi,
    getKeyringFromSeed,
    WaitUntil,
} from "ternoa-js";

const endAuctionNFT = async () => {
    try {
        await initializeApi();
        const keyring = await getKeyringFromSeed("//TernoaTestAccount");
        const NFT_ID = // update with the auctioned nft id you want to end.
        const res = await endAuction(
            NFT_ID,
            keyring,
            WaitUntil.BlockInclusion
        );
        console.log(`Auction ended for NFT id: ${res.nftId}`);
    } catch (e) {
        console.error(e);
    }
};
```

#### The expected params

```markdown
`nftId`: The ID of the auctioned NFT to end.
`keyring`: The provided keyring (containing the address) will be used to sign the transaction and pay the execution fee.
`waitUntil`: WaitUntil defines at which point we want to get the results of the transaction execution: BlockInclusion or BlockFinalization.
```

#### Response

The response provided from the blockchain event includes all the information below according to the parameters provided when ending an auction.

```markdown
`nftId`: NFT id auctioned.
`newOwner`: The new NFT owner.
`amount`: The NFT price as a string corresponding to the value in a big number.
`amountRounded`: The NFT price as a number.
`marketplaceCut`: The marketplace commission fee on the auctioned NFT as a string corresponding to the value in a big number.
`marketplaceCutRounded`: The marketplace commission fee on the auctioned NFT as a number.
`royaltyCut`: The NFT creator royalty fee on the auctioned NFT as a string corresponding to the value in a big number.
`royaltyCutRounded`: The NFT creator royalty fee on the auctioned NFT as a number.
```

### Support

If you face any trouble, feel free to reach out to our community engineers in our [Discord](https://discord.gg/fUmBkPpnRu).


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ternoa.network/build-1/javascript/nft-features-and-pallets/sale-your-nft/auction/cancel-or-end-an-auction.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
